﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Printing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _978950_RadGridViewPrintingHeaders
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.radGridView1.DataSource = this.GetData();
            this.radGridView1.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill;
        }

        private DataTable GetData()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Name", typeof(string));
            dt.Columns.Add("Age", typeof(int));
            dt.Columns.Add("Date", typeof(DateTime));
            dt.Columns.Add("Bool", typeof(bool));
            dt.Columns.Add("Bool1", typeof(bool));
            dt.Columns.Add("Bool2", typeof(bool));
            for (int i = 0; i < 50; i++)
            {
                dt.Rows.Add("Name " + i, i, DateTime.Now.AddMinutes(i), i % 2 == 0 ? true : false, false, false);
            }

            return dt;
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            for (int start = this.radGridView1.Columns.Count - 1; start > 2; start--)
            {
                this.radGridView1.Columns[start].IsVisible = false;
            }

            GridPrintStyle style = new GridPrintStyle();
            style.FitWidthMode = PrintFitWidthMode.FitPageWidth;
            this.radGridView1.PrintStyle = style;

            MyPrintDocument doc = new MyPrintDocument();
            doc.HeaderHeight = 30;
            doc.HeaderFont = new Font("Arial", 12);
            doc.LeftHeader = "Left Header";
            doc.MiddleHeader = "Middle header";
            doc.RightHeader = "Right header";
            doc.AssociatedObject = this.radGridView1;

            RadPrintPreviewDialog dialog = new RadPrintPreviewDialog(doc);
            dialog.Show();

            doc.EndPrint += doc_EndPrint;
        }

        private void doc_EndPrint(object sender, PrintEventArgs e)
        {
            foreach (var col in this.radGridView1.Columns)
            {
                if (!col.IsVisible)
                {
                    col.IsVisible = true;
                }
            }
        }
    }

    public class MyPrintDocument : RadPrintDocument
    {
        protected override void PrintHeader(System.Drawing.Printing.PrintPageEventArgs args)
        {
            if (this.HeaderHeight > 0)
            {
                base.PrintHeader(args);

                this.HeaderHeight = 0;
            }
        }
    }
}
